
\    ,   (wildcards)  * ?

\ ver 0.3


\ for SPF
\ ver 0.1 - 11.06.1999  Ruvim Pinka

\ for GNU Forth -- Alex Malyshev (alexript@mail.ru)

uses StartUp
uses Ext.comment
uses Ext.var

VARS
 	m.wc
	m.wclen
	m.str
	m.strlen
	;

\    (     ... :)
: wc+
    S" m.wc @  1+  m.wc !   m.wclen @  1-  m.wclen ! " EVALUATE
; IMMEDIATE
: str+
    S" m.str @  1+  m.str !  m.strlen @ 1-  m.strlen ! " EVALUATE
; IMMEDIATE


: WildCMP   (  addr1 u1  addr2 u2 -- n )  \ case sensitive - non

\  addr1 u1  - string
\  addr2 u2  - mask
\  n =  0,      , (Yes)
\  n = -1,  -     ,    .
\           -   ,    
\               ,  
\            
\	    (No)
\  n =  1     , ..     
\                ,  
\            . (No)
\   :
\           *  - string of any symbols
\           ?  - any symbol

	m.wclen ! m.wc ! m.strlen ! m.str !

    BEGIN
        m.wclen @  0= IF   m.strlen @ 0= IF  0 EXIT THEN  -1 EXIT  THEN
        m.strlen @ 0= IF   -1 EXIT THEN

        m.wc @ C@
        DUP  [CHAR] ?  = IF DROP    str+ wc+   ELSE
        DUP  [CHAR] *  = IF DROP    wc+
                \     *
                BEGIN   m.wclen @
                    IF  m.wc @ C@ [CHAR] * =  m.wc @ C@ [CHAR] ? =  OR
                    ELSE  0 EXIT  THEN \ ,  * -   
                WHILE wc+ REPEAT
                BEGIN  \    
                    m.str @ m.strlen @  m.wc @ m.wclen @  RECURSE  0<>
                WHILE  \    ,   
                    m.strlen @ 0= IF -1  EXIT THEN   str+
                REPEAT
        ELSE
               m.str @ C@
               2DUP  <> IF
             > IF  -1 EXIT    ELSE   1 EXIT   THEN  THEN 2DROP
            str+ wc+
        THEN THEN
    AGAIN
;


/*
: test

  S" 012WebMaster" S" ???w??mas*" WildCMP
  CR ." result: " .

  S" 012webmaster" S" ???w??mas*" WildCMP
  CR ." result: " .
;
*/

/*
: test 
	S" /~alex/" S" */" WildCMP
	CR ." result: " .
	;
*/	
