\ MIME support

\ Copyright (C) 2000 Alex Malyshev (alexript@mail.ru)

\ This is free software; you can redistribute it and/or
\ modify it under the terms of the GNU General Public License
\ as published by the Free Software Foundation; either version 2
\ of the License, or (at your option) any later version.

\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\ GNU General Public License for more details.

\ You should have received a copy of the GNU General Public License
\ along with this program; if not, write to the Free Software
\ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

uses StartUp
uses Strings.mask

: isPicture	( addr u -- addr u flag )

	FALSE
	;

: isHTML	( addr u -- addr u flag )
	2DUP S" *.html" WildCMP 0= >R
	2DUP S" *.HTML" WildCMP 0= R> OR >R
	2DUP S" *.htm" WildCMP 0= R> OR >R
	2DUP S" *.HTM" WildCMP 0= R> OR
	;
	
	
: isFS          ( addr u -- addr u flag )
	2DUP S" *.fs" WildCMP 0= >R
	2DUP S" *.FS" WildCMP 0= R> OR 
	;
	
: isCGI          ( addr u -- addr u flag )
	2DUP S" *.cgi" WildCMP 0= >R
	2DUP S" *.CGI" WildCMP 0= R> OR 
	;
	
: isMIME
	isPicture >R
	isHTML    R> OR >R
	isFS      R> OR >R
	isCGI     R> OR
	;
	
